# This file was auto-generated by Fern from our API Definition.

import enum
import typing

T_Result = typing.TypeVar("T_Result")


class Resource(str, enum.Enum):
    PROFILE = "profile"
    ACTIVITY = "activity"
    SLEEP = "sleep"
    BODY = "body"
    WORKOUTS = "workouts"
    WORKOUT_STREAM = "workout_stream"
    CONNECTION = "connection"
    ORDER = "order"
    RESULT = "result"
    APPOINTMENT = "appointment"
    GLUCOSE = "glucose"
    HEARTRATE = "heartrate"
    HRV = "hrv"
    IGE = "ige"
    IGG = "igg"
    BLOOD_OXYGEN = "blood_oxygen"
    BLOOD_PRESSURE = "blood_pressure"
    CHOLESTEROL = "cholesterol"
    DEVICE = "device"
    WEIGHT = "weight"
    FAT = "fat"
    BODY_TEMPERATURE = "body_temperature"
    BODY_TEMPERATURE_DELTA = "body_temperature_delta"
    MEAL = "meal"
    WATER = "water"
    CAFFEINE = "caffeine"
    MINDFULNESS_MINUTES = "mindfulness_minutes"
    STEPS = "steps"
    CALORIES_ACTIVE = "calories_active"
    DISTANCE = "distance"
    FLOORS_CLIMBED = "floors_climbed"
    RESPIRATORY_RATE = "respiratory_rate"
    VO_2_MAX = "vo2_max"
    CALORIES_BASAL = "calories_basal"
    STRESS_LEVEL = "stress_level"
    MENSTRUAL_CYCLE = "menstrual_cycle"
    SLEEP_CYCLE = "sleep_cycle"
    ELECTROCARDIOGRAM = "electrocardiogram"
    ELECTROCARDIOGRAM_VOLTAGE = "electrocardiogram_voltage"
    AFIB_BURDEN = "afib_burden"
    HEART_RATE_ALERT = "heart_rate_alert"
    WORKOUT_DURATION = "workout_duration"
    INSULIN_INJECTION = "insulin_injection"
    CARBOHYDRATES = "carbohydrates"
    NOTE = "note"
    SLEEP_STREAM = "sleep_stream"
    HYPNOGRAM = "hypnogram"

    def visit(
        self,
        profile: typing.Callable[[], T_Result],
        activity: typing.Callable[[], T_Result],
        sleep: typing.Callable[[], T_Result],
        body: typing.Callable[[], T_Result],
        workouts: typing.Callable[[], T_Result],
        workout_stream: typing.Callable[[], T_Result],
        connection: typing.Callable[[], T_Result],
        order: typing.Callable[[], T_Result],
        result: typing.Callable[[], T_Result],
        appointment: typing.Callable[[], T_Result],
        glucose: typing.Callable[[], T_Result],
        heartrate: typing.Callable[[], T_Result],
        hrv: typing.Callable[[], T_Result],
        ige: typing.Callable[[], T_Result],
        igg: typing.Callable[[], T_Result],
        blood_oxygen: typing.Callable[[], T_Result],
        blood_pressure: typing.Callable[[], T_Result],
        cholesterol: typing.Callable[[], T_Result],
        device: typing.Callable[[], T_Result],
        weight: typing.Callable[[], T_Result],
        fat: typing.Callable[[], T_Result],
        body_temperature: typing.Callable[[], T_Result],
        body_temperature_delta: typing.Callable[[], T_Result],
        meal: typing.Callable[[], T_Result],
        water: typing.Callable[[], T_Result],
        caffeine: typing.Callable[[], T_Result],
        mindfulness_minutes: typing.Callable[[], T_Result],
        steps: typing.Callable[[], T_Result],
        calories_active: typing.Callable[[], T_Result],
        distance: typing.Callable[[], T_Result],
        floors_climbed: typing.Callable[[], T_Result],
        respiratory_rate: typing.Callable[[], T_Result],
        vo_2_max: typing.Callable[[], T_Result],
        calories_basal: typing.Callable[[], T_Result],
        stress_level: typing.Callable[[], T_Result],
        menstrual_cycle: typing.Callable[[], T_Result],
        sleep_cycle: typing.Callable[[], T_Result],
        electrocardiogram: typing.Callable[[], T_Result],
        electrocardiogram_voltage: typing.Callable[[], T_Result],
        afib_burden: typing.Callable[[], T_Result],
        heart_rate_alert: typing.Callable[[], T_Result],
        workout_duration: typing.Callable[[], T_Result],
        insulin_injection: typing.Callable[[], T_Result],
        carbohydrates: typing.Callable[[], T_Result],
        note: typing.Callable[[], T_Result],
        sleep_stream: typing.Callable[[], T_Result],
        hypnogram: typing.Callable[[], T_Result],
    ) -> T_Result:
        if self is Resource.PROFILE:
            return profile()
        if self is Resource.ACTIVITY:
            return activity()
        if self is Resource.SLEEP:
            return sleep()
        if self is Resource.BODY:
            return body()
        if self is Resource.WORKOUTS:
            return workouts()
        if self is Resource.WORKOUT_STREAM:
            return workout_stream()
        if self is Resource.CONNECTION:
            return connection()
        if self is Resource.ORDER:
            return order()
        if self is Resource.RESULT:
            return result()
        if self is Resource.APPOINTMENT:
            return appointment()
        if self is Resource.GLUCOSE:
            return glucose()
        if self is Resource.HEARTRATE:
            return heartrate()
        if self is Resource.HRV:
            return hrv()
        if self is Resource.IGE:
            return ige()
        if self is Resource.IGG:
            return igg()
        if self is Resource.BLOOD_OXYGEN:
            return blood_oxygen()
        if self is Resource.BLOOD_PRESSURE:
            return blood_pressure()
        if self is Resource.CHOLESTEROL:
            return cholesterol()
        if self is Resource.DEVICE:
            return device()
        if self is Resource.WEIGHT:
            return weight()
        if self is Resource.FAT:
            return fat()
        if self is Resource.BODY_TEMPERATURE:
            return body_temperature()
        if self is Resource.BODY_TEMPERATURE_DELTA:
            return body_temperature_delta()
        if self is Resource.MEAL:
            return meal()
        if self is Resource.WATER:
            return water()
        if self is Resource.CAFFEINE:
            return caffeine()
        if self is Resource.MINDFULNESS_MINUTES:
            return mindfulness_minutes()
        if self is Resource.STEPS:
            return steps()
        if self is Resource.CALORIES_ACTIVE:
            return calories_active()
        if self is Resource.DISTANCE:
            return distance()
        if self is Resource.FLOORS_CLIMBED:
            return floors_climbed()
        if self is Resource.RESPIRATORY_RATE:
            return respiratory_rate()
        if self is Resource.VO_2_MAX:
            return vo_2_max()
        if self is Resource.CALORIES_BASAL:
            return calories_basal()
        if self is Resource.STRESS_LEVEL:
            return stress_level()
        if self is Resource.MENSTRUAL_CYCLE:
            return menstrual_cycle()
        if self is Resource.SLEEP_CYCLE:
            return sleep_cycle()
        if self is Resource.ELECTROCARDIOGRAM:
            return electrocardiogram()
        if self is Resource.ELECTROCARDIOGRAM_VOLTAGE:
            return electrocardiogram_voltage()
        if self is Resource.AFIB_BURDEN:
            return afib_burden()
        if self is Resource.HEART_RATE_ALERT:
            return heart_rate_alert()
        if self is Resource.WORKOUT_DURATION:
            return workout_duration()
        if self is Resource.INSULIN_INJECTION:
            return insulin_injection()
        if self is Resource.CARBOHYDRATES:
            return carbohydrates()
        if self is Resource.NOTE:
            return note()
        if self is Resource.SLEEP_STREAM:
            return sleep_stream()
        if self is Resource.HYPNOGRAM:
            return hypnogram()
